'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var LOG_LEVELS = {
    ERROR: 1,
    WARN: 2,
    INFO: 3,
    DEBUG: 4
};

/**
* Write logs
* @class Logger
*/

var Logger = function () {
    /**
    * @constructor
    * @param {string} name - Name of the logger
    */
    function Logger(name, level) {
        _classCallCheck(this, Logger);

        this.name = name;
        this.level = level || 'DEBUG';
    }

    /**
    * Write log
    * @method
    * @memeberof Logger
    * @param {string|object} msg - Logging message or object
    * @param {string} type - log type, default INFO
    */


    _createClass(Logger, [{
        key: 'log',
        value: function log(msg, type) {
            type = type || 'INFO';

            if (LOG_LEVELS[this.level] < LOG_LEVELS[type]) {
                return;
            }

            if ((typeof msg === 'undefined' ? 'undefined' : _typeof(msg)) === 'object') {
                console.log('[' + type + '] ' + this.name + ' - ');
                console.log(msg);
            } else {
                console.log('[' + type + '] ' + this.name + ' - ' + msg);
            }
        }

        /**
        * Write INFO log
        * @method
        * @memeberof Logger
        * @param {string|object} msg - Logging message or object
        */

    }, {
        key: 'info',
        value: function info(msg) {
            this.log(msg, 'INFO');
        }

        /**
        * Write WARN log
        * @method
        * @memeberof Logger
        * @param {string|object} msg - Logging message or object
        */

    }, {
        key: 'warn',
        value: function warn(msg) {
            this.log(msg, 'WARN');
        }

        /**
        * Write ERROR log
        * @method
        * @memeberof Logger
        * @param {string|object} msg - Logging message or object
        */

    }, {
        key: 'error',
        value: function error(msg) {
            this.log(msg, 'ERROR');
        }

        /**
        * Write DEBUG log
        * @method
        * @memeberof Logger
        * @param {string|object} msg - Logging message or object
        */

    }, {
        key: 'debug',
        value: function debug(msg) {
            this.log(msg, 'DEBUG');
        }
    }]);

    return Logger;
}();

exports.default = Logger;
;