'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _logger = require('./logger');

var _logger2 = _interopRequireDefault(_logger);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var logger = new Loggger('Session');

/**
* Wraps sessionStorage. Extend with the ability to store objects
* @class Session
*/

var Session = function () {
    function Session() {
        _classCallCheck(this, Session);
    }

    _createClass(Session, null, [{
        key: 'get',

        /**
        * Get value from current session
        * @method
        * @static
        * @memberof Session
        * @param {string} key - Session key
        */
        value: function get(key) {
            var value = sessionStorage.getItem(key);
            if (!value) {
                return value;
            }

            try {
                var obj = JSON.parse(value);
                return obj.data;
            } catch (err) {
                logger.error(err);
                return null;
            }
        }

        /**
        * Set value to current session
        * @method
        * @static
        * @memberof Session
        * @param {string} key - Session key
        * @param {object} value - Session value
        */

    }, {
        key: 'set',
        value: function set(key, value) {
            var value_str = JSON.stringify({ data: value });
            sessionStorage.setItem(key, value_str);
        }

        /**
        * Remove value from session
        * @method
        * @static
        * @memberof Session
        * @param {string} key - Session key
        */

    }, {
        key: 'remove',
        value: function remove(key) {
            sessionStorage.removeItem(key);
        }

        /**
        * Clear the session
        * @method
        * @static
        * @memberof Session
        */

    }, {
        key: 'clear',
        value: function clear() {
            sessionStorage.clear();
        }
    }]);

    return Session;
}();

exports.default = Session;
;