import Logger from './logger';

const logger = new Loggger('Session');

/**
* Wraps sessionStorage. Extend with the ability to store objects
* @class Session
*/
export default class Session {
    /**
    * Get value from current session
    * @method
    * @static
    * @memberof Session
    * @param {string} key - Session key
    */
    static get(key) {
        const value = sessionStorage.getItem(key);
        if (!value) { return value; }

        try {
            const obj = JSON.parse(value);
            return obj.data;
        } catch(err) {
            logger.error(err);
            return null;
        }
    }

    /**
    * Set value to current session
    * @method
    * @static
    * @memberof Session
    * @param {string} key - Session key
    * @param {object} value - Session value
    */
    static set(key, value) {
        const value_str = JSON.stringify({ data: value });
        sessionStorage.setItem(key, value_str);
    }

    /**
    * Remove value from session
    * @method
    * @static
    * @memberof Session
    * @param {string} key - Session key
    */
    static remove(key) {
        sessionStorage.removeItem(key);
    }

    /**
    * Clear the session
    * @method
    * @static
    * @memberof Session
    */
    static clear() {
        sessionStorage.clear();
    }
};
